[Skip to main content](https://www.t-mobile.com#content-main)
[](https://www.t-mobile.com/advertising-solutions)
[](https://www.t-mobile.com/advertising-solutions)
- [Audience Insights](https://www.t-mobile.com/advertising-solutions/audience-insights)
- [Media Solutions](https://www.t-mobile.com) Media Solutions
- [Mobile Media](https://www.t-mobile.com/advertising-solutions/mobile-media#INTNAV=tNAV:MediaSolutions:MobileMedia)
- [App Install](https://www.t-mobile.com/advertising-solutions/app-install#INTNAV=tNAV:MediaSolutions:AppInstall)
- [Rideshare Advertising](https://www.t-mobile.com/advertising-solutions/rideshare-advertising#INTNAV=tNav:MediaSolutions:RideshareAdvertising)
- [Retail Media](https://www.t-mobile.com) Retail Media
- [Advertisers](https://www.t-mobile.com/advertising-solutions/in-store-retail-media-advertisers)
- [Retailers](https://www.t-mobile.com/advertising-solutions/in-store-retail-media-retailers)
- [Platforms](https://www.t-mobile.com) Platforms
- [Blis](https://blis.com/us/)
- [Vistar Media](https://www.vistarmedia.com/)
[Contact Us](https://www.t-mobile.com/advertising-solutions/contact-us.html?INTNAV=tNav%3AContactUs)
[](https://www.t-mobile.com)
## DOCUMENTATION
- [Getting Started with Magenta Advertising Platform](https://www.t-mobile.com/advertising-solutions/map/developer/documentation/getting-started-with-magenta-advertising-platform.html)
- [Publisher Data Collection Compliance Requirements](https://www.t-mobile.com/advertising-solutions/map/developer/documentation/publisher-data-collection-compliance-requirements.html)
## CONSOLE
- [Uploading Audiences](https://www.t-mobile.com/advertising-solutions/map/developer/console/uploading-audiences.html)
## DATA MARKETPLACE API
- [Overview](https://www.t-mobile.com/advertising-solutions/map/developer/data-marketplace-api/overview.html)
- [Attributes](https://www.t-mobile.com/advertising-solutions/map/developer/data-marketplace-api/attributes.htm)
- [Import](https://www.t-mobile.com/advertising-solutions/map/developer/data-marketplace-api/import.html)
- [Data File Format](https://www.t-mobile.com/advertising-solutions/map/developer/data-marketplace-api/data-file-format.html)
- [Taxonomy File Format](https://www.t-mobile.com/advertising-solutions/map/developer/data-marketplace-api/taxonomy-file-format.html)
## DATA TRANSFER AND INTEGRATION
- [](https://www.t-mobile.com)[AWS S3 Access](https://www.t-mobile.com/advertising-solutions/map/developer/data-transfer-and-integration/aws-s3-access.html)
# Attributes
Attributes represent the tags or segments of data you plan to make available in the Audience Marketplace. Each Attribute is made up of a required Name and Description field, both of which will be displayed to users when they are building Custom Segments and working with your data.
## Naming Conventions for Attributes
Rather than declaring and managing complicated hierarchical structures for organizing your Attributes, our platform expects you to name your Attributes according to a simple naming convention. Following this convention allows us to group related Attributes in the console and still gives you the ability to control the hierarchy they are displayed with.
We recommend you use the sequence " > " (space followed by greater than followed by space) in between hierarchical elements.
For example, the Audience Marketplace organizes some of its Attributes as follows:
Interest & Activity > Arts & Entertainment > Music Lovers
Interest & Activity > Arts & Entertainment > Music Lovers > Concertgoers
Interest & Activity > Arts & Entertainment > Music Lovers > Music Streamers
Interest & Activity > Arts & Entertainment > Photo & Video Enthusiasts
Interest & Activity > Arts & Entertainment > Photo & Video Enthusiasts > Photo Editors
Interest & Activity > Arts & Entertainment > Photo & Video Enthusiasts > Photo Printers
As you can see, this naming convention organizes a visual hierarchy of Attributes for customers to choose from when building segments.
Please note the Magenta Advertising Platform will not automatically "roll up" attributes. For instance, given the list of Attributes above, if I want the "Music Lovers" Attribute to contain all of the "Concertgoers" and "Music Streamers", I need to add the "Music Lovers" Attribute to every advertising identifier that I put "Concertgoers" or "Music Streamers" on.
We recommend that the actual segment name (last node in the attribute name) does not
exceed 20max characters.
One other note: we suggest you __do not__ include your brand as a component of the Attribute names. Our UI will display your brand as part of listing your Attributes to customers working in the Audience Console.
## Attribute Descriptions
Attribute descriptions are displayed in the UI to help prospective buyers understand what’s in each segment. We recommend providing a 500max character description. Also, the more unique the attribute description, the more it can help customers find your attributes in search results.
Example:
It runs like a bull, but mostly it cuts grass. The Toro Company is an American maker of lawn equipment like lawn mowers, snow blowers, and irrigation systems.
## Declaring Attributes
Attributes must be declared to the Magenta Advertising Platform using the APIs below before they appear in the files you sent to Magenta Advertising Platform for ingestion.
When you create an Attribute via the API below, you will be given back an Attribute ID. This is the identifier you will use in the files you later send us for ingestion.
If you prefer to use your own internal identifier for each Attribute, our platform supports that. When you declare the Attribute to Magenta Advertising Platform, you can optionally supply a "Partner Foreign Key". Once declared to us, you can then use that Partner Foreign Key in data files instead.
## Attribute Device Count
A common problem in delivering your data to other platforms is knowing whether or not they are ingesting the data correctly. The API below allows you to query Magenta Advertising Platform on a per-Attribute basis to see the current count of devices associated with each Attribute. This allows you to validate that ingestion is correctly happening.
## API Endpoint
All operations described below are associated with
[https://api.magentamarketing.com/v1/marketplace/attribute](https://api.magentamarketing.com/v1/marketplace/attribute) .
## List Attributes
Retrieves a list of all attributes you have defined.
__cURL__
```
curl --header "Authorization: Bearer
" https://api.magentamarketing.com/v1/marketplace/attribute"
```
## Response
__JSON__
```
[
{
"attribute_id":3,
"name":"Auto Shoppers",
"description":"People who have shopped for car in last 30 days",
"visible":true,
"device_count":"23456"
},
{
"attribute_id":4,
"name":"Job Hunter",
"description":"People who are hunting for a job",
"visible":false,
"device_count":"0"
}
]
```
## Get Attribute
Get a single attribute.
__cURL__
```
curl --header "Authorization: Bearer " https://api.magentamarketing.com/v1/marketplace/attribute/3"
```
## Response
__JSON__
```
{
"attribute_id":3,
"name":"Auto Shoppers",
"description":"People who have shopped for car in last 30 days",
"visible":true,
"device_count":"23456"
}
```
## Get Attribute by Name
Alternate method to get a single attribute. Keyed on name.
__cURL__
```
curl -X GET -H "Authorization: Bearer " "https://api.magentamarketing.com/v1/marketplace/attribute?name=test3"
```
## Response
__JSON__
```
{
"attribute_id": 4,
"name": "test3",
"description": "Another test",
"visible": false,
"device_count": "0",
"partner_foreign_key": null
}
```
## Get Attribute by Partner Foreign Key
Alternate method to get a single attribute. Keyed on partner\_foreign\_key.
__cURL__
```
curl -X GET -H "Authorization: Bearer " "https://api.magentamarketing.com/v1/marketplace/attribute?partner_foreign_key=124"
```
## Response
__JSON__
```
{
"attribute_id": 1,
"name": "Updated Test",
"description": "Updated Test",
"visible": false,
"device_count": "0",
"partner_foreign_key": "124"
}
```
## Create Attribute
Creates a new attribute
## Parameters
Field Required Type Description
name Y string Name of attribute. Descriptive to end user. Shows up in PushSpring console. Must be unique.
description Y string Description of what the attribute represents. Shows up in PushSpring console.
partner\_foreign\_key N string Key in partner system. When importing data either the attribute\_id or this key may be used. Must be unique.
Cannot contain a ,
visible N boolan If not specified defaults to false. Whether or not the attribute shows up in the MAP Marketplace console..
## Sample
__cURL__
```
curl -X POST -H "Authorization: Bearer " -H "Content-Type: application/json" -d '{
"name": "Sample",
"description":"A sample attribute",
"category": "Sample"
}' "https://api.magentamarketing.com/v1/marketplace/attribute"
```
## Response
__JSON__
```
{
"attribute_id":8
}
```
```
curl -X PATCH -H "Authorization: Bearer " -H "Content-Type: application/json" -d '{
"description": "Updated Sample",
"visible": true
}' "https://api.magentamarketing.com/v1/marketplace/attribute/1"
```
## Update Attribute
Updates an attribute. Only the included parameters are updated.
## Parameters
Same as Create Attribute
## Sample
__cURL__
```
curl -X PATCH -H "Authorization: Bearer " -H "Content-Type: application/json" -d '{
"description": "Updated Sample",
"visible": true
}' "https://api.magentamarketing.com/v1/marketplace/attribute/1"
```
## Response
If successful returns a 204 No content
## Hello! Want to stay logged in?
To keep your accounts safe, you'll be automatically logged out in:
Yes, stay logged in
No, log me out
## Share your screen while on a call or in store
__Get guided support from an Expert in real time__
- For your security, personal info, tabs, and notifications are automatically hidden.
- You can stop screen sharing at any time.
- Experts can only see what’s on T-Mobile.com.
- Don’t use screen share while driving or in any situation where it's unsafe to focus on your screen.
By clicking 'Accept and continue,' you are consenting to allow the Expert to view your screen for assisted navigation. This session may be recorded. To learn more, please visit the
[__T-Mobile Privacy Notice__](https://www.t-mobile.com/privacy-center/privacy-notices/t-mobile-privacy-notice).
Accept and continue
No thanks
__Next:__ Generate a code to share with your Expert
## Share this code with your Expert
code
Once your code has been successfully entered by your Expert, this window will close and continue to the session.
## Allow screen sharing with your Expert?
Personal and sensitive data is hidden for your security and privacy.
Allow
Don’t allow
## End your session?
Ending your session will stop sharing your screen, but will not end your call.
End session
Continue session
## Your session has ended
Your screen is no longer being shared with your Expert.
OK
Share again
## You are already in an active session
OK
## Your code has expired
Generate a new one to share with your Expert.
Generate new code
T-Mobile Advertising Solutions
- [English](https://www.t-mobile.com)
- [Español](https://www.t-mobile.com)
- ### Legal
Legal
- [T-Mobile Privacy Notice](https://www.t-mobile.com/privacy-center/privacy-notices/t-mobile-privacy-notice)
- [Privacy Center](https://www.t-mobile.com/privacy-center)
- ### Contact us
Contact us
- [Contact Advertising Solutions](https://www.t-mobile.com/advertising-solutions/contact-us)
[](https://www.t-mobile.com/)
- [About](https://www.t-mobile.com/our-story)
- [Investor relations](https://investor.t-mobile.com/default.aspx?INTNAV=fNav%3AInvestorRelations)
- [Press](https://www.t-mobile.com/news)
- [Careers](https://careers.t-mobile.com?INTNAV=fNav%3ACareers)
- [Deutsche Telekom](https://www.telekom.com/en?INTNAV=fNav%3ADeutscheTelekom)
- [Puerto Rico](https://www.t-mobilepr.com/?INTNAV=fNav%3APuertoRico)
- [Privacy Notice](https://www.t-mobile.com/privacy-center/privacy-notices/t-mobile-privacy-notice)
- [Trust Center](https://security.t-mobile.com/?INTNAV=fNav%3ATrustCenter)
- [Privacy Center](https://www.t-mobile.com/privacy-center)
- [Consumer information](https://www.t-mobile.com/responsibility/consumer-info)
- [Public safety/911](https://www.t-mobile.com/responsibility/consumer-info/safety/9-1-1)
- [Terms & conditions](https://www.t-mobile.com/responsibility/legal/terms-and-conditions)
- [Terms of use](https://www.t-mobile.com/responsibility/consumer-info/policies/terms-of-use)
- [Accessibility](https://www.t-mobile.com/responsibility/consumer-info/accessibility-policy)
- [Open Internet](https://www.t-mobile.com/responsibility/consumer-info/policies/internet-service)
- [Do Not Sell or Share My Personal Information](https://www.t-mobile.com)
- [Licenses & Patents](https://www.t-mobile.com/responsibility/legal/licenses-and-patents)
- [Consumer Health Data Privacy Notice](https://www.t-mobile.com/privacy-center/privacy-notices/t-mobile-privacy-notice.html?INTNAV=fNav%3AConsumerHealthDataPrivacyNotice#health-data-privacy-notice)
- T-Mobile, the T logo, Magenta and the magenta color are registered trademarks of Deutsche Telekom AG.
- [Instagram](https://www.instagram.com/tmobile/)
- [Facebook](https://www.facebook.com/TMobile)
- [X](https://twitter.com/TMobile)
- [You Tube](https://www.youtube.com/user/TMobile/custom)
© 2026 T‑Mobile USA, Inc.

## Stay up to date with notifications
Get the latest from T-Mobile when you’re using the web. You can opt out any time.
Allow notifications Don't allow

## Get the latest from T-Mobile
Stay up to date with notifications - including offers just for you
Allow notifications Don't allow notifications

## Stay up to date with notifications
Get the latest from T-Mobile when you’re using the web. You can opt out any time.
Allow notifications Don't allow

## Get the latest from T-Mobile
Stay up to date with notifications - including offers just for you
Allow notifications Don't allow notifications